//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Tue Jan 29 07:38:53 2019
// Version: v12.0 12.500.0.22
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// MEMORY
module MEMORY(
    // Inputs
    HADDR_M0,
    HBURST_M0,
    HCLK,
    HMASTLOCK_M0,
    HPROT_M0,
    HRESETN,
    HSIZE_M0,
    HTRANS_M0,
    HWDATA_M0,
    HWRITE_M0,
    // Outputs
    HRDATA_M0,
    HREADY_M0,
    HRESP_M0
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input  [31:0] HADDR_M0;
input  [2:0]  HBURST_M0;
input         HCLK;
input         HMASTLOCK_M0;
input  [3:0]  HPROT_M0;
input         HRESETN;
input  [2:0]  HSIZE_M0;
input  [1:0]  HTRANS_M0;
input  [31:0] HWDATA_M0;
input         HWRITE_M0;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [31:0] HRDATA_M0;
output        HREADY_M0;
output [1:0]  HRESP_M0;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire   [31:0] AHB_MEM_0_AHBmslave8_HADDR;
wire   [2:0]  AHB_MEM_0_AHBmslave8_HBURST;
wire          AHB_MEM_0_AHBmslave8_HMASTLOCK;
wire   [3:0]  AHB_MEM_0_AHBmslave8_HPROT;
wire   [31:0] AHB_MEM_0_AHBmslave8_HRDATA;
wire          AHB_MEM_0_AHBmslave8_HREADY;
wire          AHB_MEM_0_AHBmslave8_HREADYOUT;
wire   [1:0]  AHB_MEM_0_AHBmslave8_HRESP;
wire          AHB_MEM_0_AHBmslave8_HSELx;
wire   [2:0]  AHB_MEM_0_AHBmslave8_HSIZE;
wire   [1:0]  AHB_MEM_0_AHBmslave8_HTRANS;
wire   [31:0] AHB_MEM_0_AHBmslave8_HWDATA;
wire          AHB_MEM_0_AHBmslave8_HWRITE;
wire   [31:0] HADDR_M0;
wire   [2:0]  HBURST_M0;
wire          HMASTLOCK_M0;
wire   [3:0]  HPROT_M0;
wire   [31:0] AHBmmaster0_HRDATA;
wire          AHBmmaster0_HREADY;
wire   [1:0]  AHBmmaster0_HRESP;
wire   [2:0]  HSIZE_M0;
wire   [1:0]  HTRANS_M0;
wire   [31:0] HWDATA_M0;
wire          HWRITE_M0;
wire          HCLK;
wire          HRESETN;
wire          AHBmmaster0_HREADY_net_0;
wire   [31:0] AHBmmaster0_HRDATA_net_0;
wire   [1:0]  AHBmmaster0_HRESP_net_0;
//--------------------------------------------------------------------
// TiedOff Nets
//--------------------------------------------------------------------
wire          GND_net;
//--------------------------------------------------------------------
// Constant assignments
//--------------------------------------------------------------------
assign GND_net = 1'b0;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign AHBmmaster0_HREADY_net_0 = AHBmmaster0_HREADY;
assign HREADY_M0                = AHBmmaster0_HREADY_net_0;
assign AHBmmaster0_HRDATA_net_0 = AHBmmaster0_HRDATA;
assign HRDATA_M0[31:0]          = AHBmmaster0_HRDATA_net_0;
assign AHBmmaster0_HRESP_net_0  = AHBmmaster0_HRESP;
assign HRESP_M0[1:0]            = AHBmmaster0_HRESP_net_0;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------AHB_MEM
AHB_MEM AHB_MEM_0(
        // Inputs
        .HCLK         ( HCLK ),
        .HRESETN      ( HRESETN ),
        .REMAP_M0     ( GND_net ),
        .HWRITE_M0    ( HWRITE_M0 ),
        .HMASTLOCK_M0 ( HMASTLOCK_M0 ),
        .HREADYOUT_S8 ( AHB_MEM_0_AHBmslave8_HREADYOUT ),
        .HADDR_M0     ( HADDR_M0 ),
        .HTRANS_M0    ( HTRANS_M0 ),
        .HSIZE_M0     ( HSIZE_M0 ),
        .HBURST_M0    ( HBURST_M0 ),
        .HPROT_M0     ( HPROT_M0 ),
        .HWDATA_M0    ( HWDATA_M0 ),
        .HRDATA_S8    ( AHB_MEM_0_AHBmslave8_HRDATA ),
        .HRESP_S8     ( AHB_MEM_0_AHBmslave8_HRESP ),
        // Outputs
        .HREADY_M0    ( AHBmmaster0_HREADY ),
        .HWRITE_S8    ( AHB_MEM_0_AHBmslave8_HWRITE ),
        .HSEL_S8      ( AHB_MEM_0_AHBmslave8_HSELx ),
        .HREADY_S8    ( AHB_MEM_0_AHBmslave8_HREADY ),
        .HMASTLOCK_S8 ( AHB_MEM_0_AHBmslave8_HMASTLOCK ),
        .HRDATA_M0    ( AHBmmaster0_HRDATA ),
        .HRESP_M0     ( AHBmmaster0_HRESP ),
        .HADDR_S8     ( AHB_MEM_0_AHBmslave8_HADDR ),
        .HTRANS_S8    ( AHB_MEM_0_AHBmslave8_HTRANS ),
        .HSIZE_S8     ( AHB_MEM_0_AHBmslave8_HSIZE ),
        .HWDATA_S8    ( AHB_MEM_0_AHBmslave8_HWDATA ),
        .HBURST_S8    ( AHB_MEM_0_AHBmslave8_HBURST ),
        .HPROT_S8     ( AHB_MEM_0_AHBmslave8_HPROT ) 
        );

//--------LSRAM_64kBytes
LSRAM_64kBytes LSRAM_64kBytes_0(
        // Inputs
        .HCLK      ( HCLK ),
        .HRESETN   ( HRESETN ),
        .HADDR     ( AHB_MEM_0_AHBmslave8_HADDR ),
        .HTRANS    ( AHB_MEM_0_AHBmslave8_HTRANS ),
        .HWRITE    ( AHB_MEM_0_AHBmslave8_HWRITE ),
        .HSIZE     ( AHB_MEM_0_AHBmslave8_HSIZE ),
        .HBURST    ( AHB_MEM_0_AHBmslave8_HBURST ),
        .HWDATA    ( AHB_MEM_0_AHBmslave8_HWDATA ),
        .HSEL      ( AHB_MEM_0_AHBmslave8_HSELx ),
        .HREADYIN  ( AHB_MEM_0_AHBmslave8_HREADY ),
        // Outputs
        .HRDATA    ( AHB_MEM_0_AHBmslave8_HRDATA ),
        .HREADYOUT ( AHB_MEM_0_AHBmslave8_HREADYOUT ),
        .HRESP     ( AHB_MEM_0_AHBmslave8_HRESP ) 
        );


endmodule
